import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/services.dart';

import 'dart:async';
import 'dart:io';
import 'dart:ui';

import 'package:flutter_aliplayer/flutter_aliplayer.dart';
import 'package:flutter_aliplayer/flutter_aliplayer_factory.dart';
import 'package:connectivity/connectivity.dart'; //监听网络变化
import 'package:flutter_aliplayer/flutter_alilistplayer.dart';
import 'package:flutter_aliplayer/flutter_alidownloader.dart';
import 'package:flutter_aliplayer/flutter_avpdef.dart';
import 'package:hsp_aliplayer/util/index.dart';
import 'package:path_provider/path_provider.dart';
import 'package:hsp_aliplayer/componets/videos/widget/index.dart';
import 'package:hsp_aliplayer/componets/videos/fragment/index.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:easy_popup/easy_popup.dart'; //弹出层


class SmallVideoPpage extends StatefulWidget {
  final ModeType playMode;
  final Map<String, dynamic> dataSourceMap;

  SmallVideoPpage({
    Key key,
    this.playMode,
    this.dataSourceMap,
  }):super(key:key);
  @override
  _SmallVideoPpageState createState() => _SmallVideoPpageState();
}

class _SmallVideoPpageState extends State<SmallVideoPpage> with WidgetsBindingObserver , TickerProviderStateMixin {
  FlutterAliplayer fAliplayer;
  int bottomIndex;
  List<Widget> mFramePage;
  ModeType _playMode;
  Map<String, dynamic> _dataSourceMap;
  OptionsFragment mOptionsFragment;
  //是否允许后台播放
  bool _mEnablePlayBack = false;
  //当前播放进度
  int _currentPosition = 0;
  //当前播放时间，用于Text展示
  int _currentPositionText = 0;
  //当前缓存进度
  int _bufferPosition = 0;
  //是否展示loading
  bool _showLoading = false;
  //loading进度
  int _loadingPercent = 0;
  //视频时长
  int _videoDuration = 1;
  //截图保存路径
  String _snapShotPath;
  //提示内容
  String _tipsContent;
  //是否展示提示内容
  bool _showTipsWidget = false;
  //是否有缩略图
  bool _thumbnailSuccess = false;
  //缩略图
  // Uint8List _thumbnailBitmap;
  ImageProvider _imageProvider;
  //当前网络状态
  ConnectivityResult _currentConnectivityResult;
  //是否显示进度栏之类
  bool _isShowTap=false;

  ///seek中
  bool _inSeek = false;

  bool _isLock = false;
  //网络状态
  bool _isShowMobileNetWork = false;

  //当前播放器状态
  int _currentPlayerState = 0;

  String extSubTitleText = '';
  //网络状态监听
  StreamSubscription _networkSubscriptiion;
  //定时器
  Timer _timer;
  //选集动画
  AnimationController _xjdhcontroller;
  //倍速动画
  AnimationController _speeddhcontroller;
  //当前播放速度
  double _playSpeed = 1.0;
  //清晰度动画
  AnimationController _cleardhcontroller;
  //动画的状态
  int _dhStatus = 0; //0：开始 1结束
  
  double _popWidth=HspSize.set(0);
  double _popBsHeight = HspSize.set(0);
  double _popQxdHeight = HspSize.set(0);

  GlobalKey<TrackFragmentState> trackFragmentKey = GlobalKey();


  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    //倍速动画
    _speeddhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
      ..addListener(() {
        setState(() {
          _popBsHeight =HspSize.set(150)*_speeddhcontroller.value;
        });
      });;//初始化动画
    //选集动画
    _xjdhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
        ..addListener(() {
      setState(() {
        _popWidth =HspSize.set(400)*_xjdhcontroller.value;
      });
    });;//初始化动画
    //清晰度动画
    _cleardhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
      ..addListener(() {
        setState(() {
          _popQxdHeight =HspSize.set(120)*_cleardhcontroller.value;
        });
      });;//初始化动画
    fAliplayer = FlutterAliPlayerFactory().createAliPlayer();
    WidgetsBinding.instance.addObserver(this);// 注册监听器-监听应用前后台状态
    _playMode = widget.playMode;
    _dataSourceMap = widget.dataSourceMap;
    //开启混音模式
    if (Platform.isIOS) {
      fAliplayer.enableMix(true);
    }

    if (Platform.isAndroid) {
      getExternalStorageDirectories().then((value) {
        if (value.length > 0) {
          _snapShotPath = value[0].path;
          return _snapShotPath;
        }
      });
    }
    //监听播放器状态改变事件
    fAliplayer.setOnStateChanged((newState) {
      _currentPlayerState = newState;  // 0准备好 3为播放 4暂停
      print("aliyun : onStateChanged $newState");
      switch (newState) {
        case FlutterAvpdef.AVPStatus_AVPStatusStarted:
          setState(() {
            _showTipsWidget = false;
            _showLoading = false;
          });
          break;
        case FlutterAvpdef.AVPStatus_AVPStatusPaused:
          break;
        default:
      }
    });

    mOptionsFragment = OptionsFragment(fAliplayer);
    mFramePage = [
      mOptionsFragment,
      PlayConfigFragment(fAliplayer),
      CacheConfigFragment(fAliplayer),
      TrackFragment(trackFragmentKey, fAliplayer),
    ];

    mOptionsFragment.setOnEnablePlayBackChanged((mEnablePlayBack) {
      this._mEnablePlayBack = mEnablePlayBack;
    });

    _initListener();
  }

  _initListener() {
    fAliplayer.setOnPrepared(() {
      Fluttertoast.showToast(msg: "OnPrepared ");
    });
    fAliplayer.setOnRenderingStart(() {
      Fluttertoast.showToast(msg: " OnFirstFrameShow ");
    });
    fAliplayer.setOnVideoSizeChanged((width, height) {});
    fAliplayer.setOnStateChanged((newState) {
      _currentPlayerState = newState;
      print("aliyun : onStateChanged $newState");
      switch (newState) {
        case FlutterAvpdef.AVPStatus_AVPStatusStarted:
          setState(() {
            _showTipsWidget = false;
            _showLoading = false;
          });
          break;
        case FlutterAvpdef.AVPStatus_AVPStatusPaused:
          break;
        default:
      }
    });
    fAliplayer.setOnLoadingStatusListener(loadingBegin: () {
      setState(() {
        _loadingPercent = 0;
        _showLoading = true;
      });
    }, loadingProgress: (percent, netSpeed) {
      _loadingPercent = percent;
      if (percent == 100) {
        _showLoading = false;
      }
      setState(() {});
    }, loadingEnd: () {
      setState(() {
        _showLoading = false;
      });
    });
    fAliplayer.setOnSeekComplete(() {
      _inSeek = false;
    });
    fAliplayer.setOnInfo((infoCode, extraValue, extraMsg) {
      if (infoCode == FlutterAvpdef.CURRENTPOSITION) {
        if (_videoDuration != 0 && extraValue <= _videoDuration) {
          _currentPosition = extraValue;
        }
        if (!_inSeek) {
          setState(() {
            _currentPositionText = extraValue;
          });
        }
      } else if (infoCode == FlutterAvpdef.BUFFEREDPOSITION) {
        _bufferPosition = extraValue;
        print(['获取缓存',extraValue]);
        setState(() {});
      } else if (infoCode == FlutterAvpdef.AUTOPLAYSTART) {
        Fluttertoast.showToast(msg: "AutoPlay");
      } else if (infoCode == FlutterAvpdef.CACHESUCCESS) {
        Fluttertoast.showToast(msg: "Cache Success");
      } else if (infoCode == FlutterAvpdef.CACHEERROR) {
        Fluttertoast.showToast(msg: "Cache Error $extraMsg");
      } else if (infoCode == FlutterAvpdef.LOOPINGSTART) {
        Fluttertoast.showToast(msg: "Looping Start");
      } else if (infoCode == FlutterAvpdef.SWITCHTOSOFTWAREVIDEODECODER) {
        Fluttertoast.showToast(msg: "change to soft ware decoder");
        mOptionsFragment.switchHardwareDecoder();
      }
    });
    fAliplayer.setOnCompletion(() {
      _showTipsWidget = true;
      _showLoading = false;
      _tipsContent = "播放完成";
      setState(() {
        _currentPosition = _videoDuration;
      });
    });
    fAliplayer.setOnTrackReady(() {
      fAliplayer.getMediaInfo().then((value) {
        _videoDuration = value['duration'];
        setState(() {});
        List thumbnails = value['thumbnails'];
        if (thumbnails != null && thumbnails.isNotEmpty) {
          fAliplayer.createThumbnailHelper(thumbnails[0]['url']);
        } else {
          _thumbnailSuccess = false;
        }
      });
      trackFragmentKey.currentState.loadData();
      setState(() {});
    });

    fAliplayer.setOnSnapShot((path) {
      print("aliyun : snapShotPath = $path");
      Fluttertoast.showToast(msg: "SnapShot Save : $path");
    });
    fAliplayer.setOnError((errorCode, errorExtra, errorMsg) {
      _showTipsWidget = true;
      _showLoading = false;
      _tipsContent = "$errorCode \n $errorMsg";
      setState(() {});
    });

    fAliplayer.setOnTrackChanged((value) {
      AVPTrackInfo info = AVPTrackInfo.fromJson(value);
      if (info != null && info.trackDefinition.length > 0) {
        trackFragmentKey.currentState.onTrackChanged(info);
        Fluttertoast.showToast(msg: "${info.trackDefinition}切换成功");
      }
    });

    fAliplayer.setOnThumbnailPreparedListener(preparedSuccess: () {
      _thumbnailSuccess = true;
    }, preparedFail: () {
      _thumbnailSuccess = false;
    });

    fAliplayer.setOnThumbnailGetListener(
        onThumbnailGetSuccess: (bitmap, range) {
          // _thumbnailBitmap = bitmap;
          var provider = MemoryImage(bitmap);
          precacheImage(provider, context).then((_) {
            setState(() {
              _imageProvider = provider;
            });
          });
        },
        onThumbnailGetFail: () {});

    this.fAliplayer.setOnSubtitleHide((trackIndex, subtitleID) {
      if (mounted) {
        setState(() {
          extSubTitleText = '';
        });
      }
    });

    this.fAliplayer.setOnSubtitleShow((trackIndex, subtitleID, subtitle) {
      if (mounted) {
        setState(() {
          extSubTitleText = subtitle;
        });
      }
    });

    _setNetworkChangedListener();
  }

  _setNetworkChangedListener() {
    _networkSubscriptiion = Connectivity()
        .onConnectivityChanged
        .listen((ConnectivityResult result) {
      if (result == ConnectivityResult.mobile) {
        fAliplayer.pause();
        setState(() {
          _isShowMobileNetWork = true;
        });
      } else if (result == ConnectivityResult.wifi) {
        //从4G网络或者无网络切换到wifi
        if (_currentConnectivityResult == ConnectivityResult.mobile ||
            _currentConnectivityResult == ConnectivityResult.none) {
          fAliplayer.play();
        }
        setState(() {
          _isShowMobileNetWork = false;
        });
      }
      _currentConnectivityResult = result;
    });
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    switch (state) {
      case AppLifecycleState.inactive:
        break;
      case AppLifecycleState.resumed:
        _setNetworkChangedListener();
        break;
      case AppLifecycleState.paused:
        if (!_mEnablePlayBack) {
          fAliplayer.pause();
        }
        if (_networkSubscriptiion != null) {
          _networkSubscriptiion.cancel();
        }
        break;
      case AppLifecycleState.detached:
        break;
    }
  }

  @override
  void dispose() {
    // TODO: implement dispose
    _xjdhcontroller.dispose();
    _speeddhcontroller.dispose();
    _cleardhcontroller.dispose();
    SystemChrome.setPreferredOrientations(
        [DeviceOrientation.portraitUp, DeviceOrientation.portraitDown]);
    if (Platform.isIOS) {
      fAliplayer.enableMix(false);
    }
    fAliplayer.stop();
    fAliplayer.destroy();
    print("销毁播放器");
    super.dispose();
    WidgetsBinding.instance.removeObserver(this);// 移除监听器
    if (_networkSubscriptiion != null) {
      _networkSubscriptiion.cancel();
    }
  }

  @override
  Widget build(BuildContext context) {
    //准备播放
    var x = 0.0;
    var y = 0.0;
    Orientation orientation = MediaQuery.of(context).orientation;
    var width = MediaQuery.of(context).size.width;

    var height;
    if (orientation == Orientation.portrait) {
      height = width * 9.0 / 16.0;
    } else {
      height = MediaQuery.of(context).size.height;
    }
    AliPlayerView aliPlayerView = AliPlayerView(
        onCreated: onViewPlayerCreated,
        x: 0.0,
        y: 0.0,
        width: width,
        height: height);
    //  OrientationBuilder根据屏幕方向更新ui
    return  OrientationBuilder(
      builder: (BuildContext context,Orientation orientation){
        return Stack(
          children: [
            Container(
              width: width,
              height: height,
              color: Colors.black,
                child: aliPlayerView,
            ),
            //手势监听
            Positioned(
              left: 0,
              bottom:0,
              child: GestureDetector(
                behavior: HitTestBehavior.translucent,
                child: Container(
                  width: width,
                  height: height,
//                color: Colors.red,
//                child: aliPlayerView,
                ),
                onTap: (){
                  if(_dhStatus==1){
                    _xjdhcontroller.reverse();//反向动画
                    _cleardhcontroller.reverse();
                    _speeddhcontroller.reverse();
                  }else{
                    if(_isShowTap){
                      setState(() {
                        _isShowTap=false;
                      });
//                    SystemChrome.setEnabledSystemUIOverlays([]);//隐藏状态栏
                      _timer?.cancel();
                    }else{
                      setState(() {
                        _isShowTap=true;
                      });
//                    SystemChrome.setEnabledSystemUIOverlays(SystemUiOverlay.values);//显示状态栏
//                    _timer=new Timer(Duration(seconds: 10), () { //callback function
//                      setState(() {
//                        _isShowTap=false;
//                      });
//                      _dhcontroller.reverse();
//                    });
                    }
                  }
                  print(_dhStatus);
                  print('1111');


                },
              ),
            ),
            //底部进度条
            Positioned(
              left: 0,
              bottom: 0,
              child: Offstage(
                offstage: !_isShowTap,
                child: Container(
                  width: width,
                  height: 0.3*height,
                  child:Visibility(
                    visible: orientation == Orientation.portrait,
                    child: _buildContentWidget(orientation),
                    replacement: _landscapeSlider(orientation),
                  ),
                ),
              ),
            ),
            //倍速弹出框
            Positioned(
              right: HspSize.set(132),
              bottom: HspSize.set(35),
              child: Container(
                width: HspSize.set(50),
                height: _popBsHeight,
                color: Color.fromRGBO(0, 0, 0, 0.5),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: [
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("0.5倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        setState(() {
                          _playSpeed=0.5;
                        });
                        fAliplayer.setRate(0.5);
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("1.0倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        fAliplayer.setRate(1.0);
                        setState(() {
                          _playSpeed=1.0;
                        });
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("1.5倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        fAliplayer.setRate(1.5);
                        _speeddhcontroller.reverse();//反向动画
                        setState(() {
                          _playSpeed=1.5;
                        });
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("2.0倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        setState(() {
                          _playSpeed=2.0;
                        });
                        fAliplayer.setRate(2.0);
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                  ],
                ),
              ),
            ),
            //清晰度弹出框
            Positioned(
              right: HspSize.set(38),
              bottom: HspSize.set(35),
              child: Container(
                width: HspSize.set(50),
                height: _popQxdHeight,
                color: Color.fromRGBO(0, 0, 0, 0.5),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: [
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("标清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("高清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("超清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                  ],
                ),
              ),
            ),

            //选集右侧弹出框
            Positioned(
              right: 0,
              child: Container(
                width: _popWidth,
                height: height,
                color: Color.fromRGBO(0, 0, 0, 0.5),
              ),
            ),

          ],
        );
      },
    );
  }

  void onViewPlayerCreated() async {
    switch (_playMode) {
      case ModeType.URL://UrlSource播放源
        this.fAliplayer.setUrl(_dataSourceMap[DataSourceRelated.URL_KEY]);
        break;
      case ModeType.STS://VidSts播放源
        this.fAliplayer.setVidSts(
            vid: _dataSourceMap[DataSourceRelated.VID_KEY],
            region: _dataSourceMap[DataSourceRelated.REGION_KEY],
            accessKeyId: _dataSourceMap[DataSourceRelated.ACCESSKEYID_KEY],
            accessKeySecret:
            _dataSourceMap[DataSourceRelated.ACCESSKEYSECRET_KEY],
            securityToken: _dataSourceMap[DataSourceRelated.SECURITYTOKEN_KEY],
            definitionList: _dataSourceMap[DataSourceRelated.DEFINITION_LIST],
            previewTime: _dataSourceMap[DataSourceRelated.PREVIEWTIME_KEY]);
        break;
      case ModeType.AUTH://VidAuth播放源
        this.fAliplayer.setVidAuth(
            vid: _dataSourceMap[DataSourceRelated.VID_KEY],
            region: _dataSourceMap[DataSourceRelated.REGION_KEY],
            playAuth: _dataSourceMap[DataSourceRelated.PLAYAUTH_KEY],
            definitionList: _dataSourceMap[DataSourceRelated.DEFINITION_LIST],
            previewTime: _dataSourceMap[DataSourceRelated.PREVIEWTIME_KEY]);
        break;
      case ModeType.MPS://VidMps播放源
        this.fAliplayer.setVidMps(_dataSourceMap);
        break;
      default:
    }
  }

  //竖屏进度条
  _buildContentWidget(Orientation orientation) {
    return SafeArea(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.end,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
//          Padding(
//            padding: EdgeInsets.only(left: 5.0),
//            child: Text(
//              "${_currentPlayerState} : ${FormatterUtils.getTimeformatByMs(_bufferPosition)}",
//              style: TextStyle(color: Colors.white, fontSize: 11),
//            ),
//          ),
          Row(
            children: [
              SizedBox(
                width: 5.0,
              ),
              IconButton(
                icon: Icon(
                  _currentPlayerState !=3
                      ? Icons.play_arrow
                      : Icons.pause,
                  color: Colors.white,
                ),
                onPressed: () {
                  if(_currentPlayerState==3){
                    fAliplayer.pause();
                  }else if(_currentPlayerState==4){
                    fAliplayer.play();
                  }else {
                    fAliplayer.prepare();
                    fAliplayer.play();
                  }
                },
              ),
              Text(
                "${FormatterUtils.getTimeformatByMs(_currentPositionText)}",
                style: TextStyle(color: Colors.white, fontSize: 11),
              ),
              //进度条
              Expanded(
                child: AliyunSlider(
                  max: _videoDuration == 0 ? 1 : _videoDuration.toDouble(),
                  min: 0,
                  bufferColor: Colors.white,
                  bufferValue: _bufferPosition.toDouble(),
                  value: _currentPosition.toDouble(),
                  onChangeStart: (value) {
                    _inSeek = true;
                    _showLoading = false;
                    setState(() {});
                  },
                  onChangeEnd: (value) {
                    _inSeek = false;
                    setState(() {
                      if (_currentPlayerState == FlutterAvpdef.completion &&
                          _showTipsWidget) {
                        setState(() {
                          _showTipsWidget = false;
                        });
                      }
                    });
                    fAliplayer.seekTo(
                        value.ceil(),
                        GlobalSettings.mEnableAccurateSeek
                            ? FlutterAvpdef.ACCURATE
                            : FlutterAvpdef.INACCURATE);
                  },
                  onChanged: (value) {
                    if (_thumbnailSuccess) {
                      fAliplayer.requestBitmapAtPosition(value.ceil());
                    }
                    setState(() {
                      _currentPosition = value.ceil();
                    });
                  },
                ),
              ),
              Text(
                "${FormatterUtils.getTimeformatByMs(_videoDuration)}",
                style: TextStyle(color: Colors.white, fontSize: 11),
              ),
              IconButton(
                icon: Icon(
                  orientation == Orientation.portrait
                      ? Icons.fullscreen
                      : Icons.fullscreen_exit,
                  color: Colors.white,
                ),
                onPressed: () {
                  SystemChrome.setEnabledSystemUIOverlays([]);//隐藏状态栏
                  SystemChrome.setEnabledSystemUIOverlays([]);
                    SystemChrome.setPreferredOrientations([
                      DeviceOrientation.landscapeLeft,
                      DeviceOrientation.landscapeRight
                    ]);
                },
              ),
            ],
          ),
        ],
      ),
    );
  }
  //横屏进度条
  _landscapeSlider(Orientation orientation){
    return SafeArea(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.end,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Row(
            children: [
              Text(
                "${FormatterUtils.getTimeformatByMs(_currentPositionText)}",
                style: TextStyle(color: Colors.white, fontSize: 11),
              ),
              //进度条
              Expanded(
                child: AliyunSlider(
                  max: _videoDuration == 0 ? 1 : _videoDuration.toDouble(),
                  min: 0,
                  bufferColor: Colors.white,
                  bufferValue: _bufferPosition.toDouble(),
                  value: _currentPosition.toDouble(),
                  onChangeStart: (value) {
                    _inSeek = true;
                    _showLoading = false;
                    setState(() {});
                  },
                  onChangeEnd: (value) {
                    _inSeek = false;
                    setState(() {
                      if (_currentPlayerState == FlutterAvpdef.completion &&
                          _showTipsWidget) {
                        setState(() {
                          _showTipsWidget = false;
                        });
                      }
                    });
                    fAliplayer.seekTo(
                        value.ceil(),
                        GlobalSettings.mEnableAccurateSeek
                            ? FlutterAvpdef.ACCURATE
                            : FlutterAvpdef.INACCURATE);
                  },
                  onChanged: (value) {
                    if (_thumbnailSuccess) {
                      fAliplayer.requestBitmapAtPosition(value.ceil());
                    }
                    setState(() {
                      _currentPosition = value.ceil();
                    });
                  },
                ),
              ),
              Text(
                "${FormatterUtils.getTimeformatByMs(_videoDuration)}",
                style: TextStyle(color: Colors.white, fontSize: 11),
              )
            ],
          ),
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Container(
                child: Row(
                  children: [
                    //播放暂停
                    IconButton(
                      icon: Icon(
                        _currentPlayerState !=3
                            ? Icons.play_arrow
                            : Icons.pause,
                        color: Colors.white,
                      ),
                      onPressed: () {
                        if(_currentPlayerState==3){
                          fAliplayer.pause();
                        }else if(_currentPlayerState==4){
                          fAliplayer.play();
                        }else {
                          fAliplayer.prepare();
                          fAliplayer.play();
                        }
                      },
                    ),
                  ],
                ),
              ),
              Container(
                child: Row(
                  children: [
                    InkWell(
                      child: Text(_playSpeed==1.0?"1.0x":(_playSpeed==0.5?'0.5x':_playSpeed==1.5?'1.5x':'2.0x'),textDirection:TextDirection.rtl,style: TextStyle(color: Colors.white,height: 1),),
                      onTap: (){
                        _cleardhcontroller.reverse();
                        _xjdhcontroller.reverse();
                        print(['倍速',_dhStatus]);
                        if(_dhStatus==0){
                          _speeddhcontroller.forward();
                        }else{
                          _speeddhcontroller.reverse();//反向动画
                        }
                        print(['倍速1',_dhStatus]);
                      },
                    ),
                    SizedBox(
                      width: HspSize.set(20),
                    ),
                    InkWell(
                      child: Text("选集",style: TextStyle(color: Colors.white,height: 1),),
                      onTap: (){
                        _speeddhcontroller.reverse();
                        _cleardhcontroller.reverse();
                        print(['选集',_dhStatus]);
                        if(_dhStatus==0){
                          _xjdhcontroller.forward();
                        }else{
                          _xjdhcontroller.reverse();//反向动画
                        }
                        print(['选集1',_dhStatus]);
                      },
                    ),
                    SizedBox(
                      width: HspSize.set(20),
                    ),
                    InkWell(
                      child: Text("高清",style: TextStyle(color: Colors.white,height: 1),),
                      onTap: (){
                        _speeddhcontroller.reverse();
                        _xjdhcontroller.reverse();
                        print(['高清',_dhStatus]);
                        if(_dhStatus==0){
                          _cleardhcontroller.forward();
                        }else{
                          _cleardhcontroller.reverse();//反向动画
                        }
                        print(['高清1',_dhStatus]);
                      },
                    ),
                    //竖屏
                    IconButton(
                      icon: Icon(
                        Icons.fullscreen_exit,
                        color: Colors.white,
                      ),
                      onPressed: () {
                        SystemChrome.setEnabledSystemUIOverlays(SystemUiOverlay.values);//显示状态栏
                        SystemChrome.setEnabledSystemUIOverlays(SystemUiOverlay.values);
                        SystemChrome.setPreferredOrientations([
                          DeviceOrientation.portraitUp,
                          DeviceOrientation.portraitDown
                        ]);
                      },
                    ),
                  ],
                ),
              )
            ],
          ),
        ],
      ),
    );
  }
}

