library hsp_aliplayer;

/// A Calculator.
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';
import 'package:flutter/services.dart';

import 'dart:async';
import 'dart:io';
import 'dart:ui';

import 'package:flutter_aliplayer/flutter_aliplayer.dart';
import 'package:flutter_aliplayer/flutter_aliplayer_factory.dart';
import 'package:connectivity/connectivity.dart'; //监听网络变化
import 'package:flutter_aliplayer/flutter_alilistplayer.dart';
import 'package:flutter_aliplayer/flutter_alidownloader.dart';
import 'package:flutter_aliplayer/flutter_avpdef.dart';
import 'package:hsp_aliplayer/util/index.dart';
import 'package:path_provider/path_provider.dart';
import 'package:hsp_aliplayer/componets/videos/widget/index.dart';
import 'package:hsp_aliplayer/componets/videos/fragment/index.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:screen/screen.dart';//屏幕亮度设置
import 'package:cupertino_icons/cupertino_icons.dart';
import 'package:easy_popup/easy_popup.dart'; //弹出层


class HspAliPlayer extends StatefulWidget {
  final ModeType playMode;
//  final List<Map<String, dynamic>> dataSourceMap;
  final HspPlayType playType;
  final dataSourceMap;
  final int videoIndex;
  Orientation orientation;
  bool isAutoPaly;//是否视频解析完成自动播放
  final String thumbnail;//缩略图
  final String xuanChuanImg;//视频解析时候的宣传图

  HspAliPlayer({
    Key key,
    this.playMode,
    this.playType,
    this.dataSourceMap,
    this.videoIndex=0,
    this.isAutoPaly=true,
    this.thumbnail,
    this.xuanChuanImg,
    this.orientation=Orientation.portrait
  }):super(key:key);
  @override
  _HspAliPlayerState createState() => _HspAliPlayerState();
}

class _HspAliPlayerState extends State<HspAliPlayer> with WidgetsBindingObserver , TickerProviderStateMixin {
//  FlutterAliListPlayer fAliplayer;//播放器
  var fAliplayer;//播放器
  int bottomIndex;
  List<Widget> mFramePage;
  ModeType _playMode;
//  List<Map<String, dynamic>> _dataSourceMap;//视频源
  var _dataSourceMap;//视频源
  OptionsFragment mOptionsFragment;
  //视频index
  int _videoIndex = 0;
  //是否显示首屏图片
  bool _showFristImg = true;
  //竖屏 横屏
  Orientation _orientation;
  //视频准备好后是否自动播放
  bool _mEnablePlayBack = false;
  //是否允许后台播放
  bool _isAutoPaly = true;
  //当前播放进度
  int _currentPosition = 0;
  //当前播放时间，用于Text展示
  int _currentPositionText = 0;
  //当前缓存进度
  int _bufferPosition = 0;
  //是否展示loading
  bool _showLoading = false;
  //是否视频准备中
  bool _showReadying = true;
  //loading进度
  int _loadingPercent = 0;
  //视频时长
  int _videoDuration = 1;
  //截图保存路径
  String _snapShotPath;
  //提示内容
  String _tipsContent;
  //是否展示提示内容
  bool _showTipsWidget = false;
  //是否有缩略图
  bool _thumbnailSuccess = false;
  //缩略图
  // Uint8List _thumbnailBitmap;
  ImageProvider _imageProvider;
  //当前网络状态
  ConnectivityResult _currentConnectivityResult;
  //是否显示进度栏之类
  bool _isShowTap=true;

  ///seek中
  bool _inSeek = false;
  //是否锁屏
  bool _isLock = false;
  //当前按下的纵坐标点
  double nowDy = 0.0;
  //当前滑动的是音量还是亮度
  bool isVolume = true;//true为音量 false为亮度
  //是否显示音量亮度状态文字
  bool isShowVolumeAndLight =false;
  //屏幕亮度
  double brightness=0.0;
  //视频音量
  double videoVolume=0.5;
  //网络状态
  bool _isShowMobileNetWork = false;

  //当前播放器状态
  int _currentPlayerState = 0;

  String extSubTitleText = '';
  //网络状态监听
  StreamSubscription _networkSubscriptiion;
  //定时器
  Timer _timer;
  //选集动画
  AnimationController _xjdhcontroller;
  //倍速动画
  AnimationController _speeddhcontroller;
  //当前播放速度
  double _playSpeed = 1.0;
  //清晰度动画
  AnimationController _cleardhcontroller;
  //动画的状态
  int _dhStatus = 0; //0：开始 1结束

  double _popWidth=HspSize.set(0);
  double _popBsHeight = HspSize.set(0);
  double _popQxdHeight = HspSize.set(0);

  GlobalKey<TrackFragmentState> trackFragmentKey = GlobalKey();


  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    //防止进入睡眠模式:
    Screen.keepOn(true);
    //创建播放器
    if( widget.playType == HspPlayType.Live){//是否为直播
      fAliplayer = FlutterAliPlayerFactory().createAliPlayer();
    }else{
      fAliplayer = FlutterAliPlayerFactory().createAliListPlayer();
      fAliplayer.setPreloadCount(1);
    }
    //设置画面缩放模式：0宽高比填充，1宽高比适应，2拉伸填充
    fAliplayer.setScalingMode(0);
    print(['创建播放器']);
    //倍速动画
    _speeddhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
      ..addListener(() {
        setState(() {
          _popBsHeight =HspSize.set(150)*_speeddhcontroller.value;
        });
      });;//初始化动画
    //选集动画
    _xjdhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
      ..addListener(() {
        setState(() {
          _popWidth =HspSize.set(400)*_xjdhcontroller.value;
        });
      });;//初始化动画
    //清晰度动画
    _cleardhcontroller = AnimationController(vsync: this,duration: Duration(milliseconds: 100))
      ..addStatusListener((AnimationStatus status){
        if(status==AnimationStatus.completed){
          setState(() {
            _dhStatus=1;
          });
        }else if(status==AnimationStatus.dismissed){
          setState(() {
            _dhStatus=0;
          });
        }
      })
      ..addListener(() {
        setState(() {
          _popQxdHeight =HspSize.set(120)*_cleardhcontroller.value;
        });
      });;//初始化动画

    WidgetsBinding.instance.addObserver(this);// 注册监听器-监听应用前后台状态
    _playMode = widget.playMode;
    _dataSourceMap = widget.dataSourceMap;
    _orientation = widget.orientation;
    _isAutoPaly = widget.isAutoPaly;
    _videoIndex = widget.videoIndex;
    //开启混音模式
    if (Platform.isIOS) {
      fAliplayer.enableMix(true);
    }

    if (Platform.isAndroid) {
      getExternalStorageDirectories().then((value) {
        if (value.length > 0) {
          _snapShotPath = value[0].path;
          return _snapShotPath;
        }
      });
    }


    mOptionsFragment = OptionsFragment(fAliplayer);
    mFramePage = [
      mOptionsFragment,
      PlayConfigFragment(fAliplayer),
      CacheConfigFragment(fAliplayer),
      TrackFragment(trackFragmentKey, fAliplayer),
    ];

    mOptionsFragment.setOnEnablePlayBackChanged((mEnablePlayBack) {
      this._mEnablePlayBack = mEnablePlayBack;
    });
    print(['视频信息0']);
    _initListener();
  }
    //播放器监听事件
  _initListener() {
    //准备完成事件
    fAliplayer.setOnPrepared(() {
      Fluttertoast.showToast(msg: "OnPrepared ");
      setState(() {
        _showReadying = false;
        _isShowTap=true;
      });
      print("准备完成");
    });
    //首帧渲染显示事件
    fAliplayer.setOnRenderingStart(() {
      Fluttertoast.showToast(msg: " OnFirstFrameShow ");
    });
    //视频分辨率变化回调
    fAliplayer.setOnVideoSizeChanged((width, height) {});
    //监听播放器状态改变事件
    fAliplayer.setOnStateChanged((newState) {
      _currentPlayerState = newState;  // 0准备好 3为播放 4暂停
      print("aliyun : onStateChanged $newState");
      switch (newState) {
        case FlutterAvpdef.AVPStatus_AVPStatusStarted:
          setState(() {
            _showTipsWidget = false;
            _showLoading = false;
          });
          break;
        case FlutterAvpdef.AVPStatus_AVPStatusPaused:
          break;
        default:
      }
    });
    //缓存
    fAliplayer.setOnLoadingStatusListener(loadingBegin: () {
      setState(() {
        _loadingPercent = 0;
        _showLoading = true;
      });
    }, loadingProgress: (percent, netSpeed) {
      _loadingPercent = percent;
      if (percent == 100) {
        _showLoading = false;
      }
      setState(() {});
    }, loadingEnd: () {
      setState(() {
        _showLoading = false;
      });
    });
    fAliplayer.setOnSeekComplete(() {
      _inSeek = false;
    });
    //其他信息的事件，type包括了：循环播放开始，缓冲位置，当前播放位置，自动播放开始等
    fAliplayer.setOnInfo((infoCode, extraValue, extraMsg) {
      if (infoCode == FlutterAvpdef.CURRENTPOSITION) {
        if (_videoDuration != 0 && extraValue <= _videoDuration) {
          _currentPosition = extraValue;
        }
        if (!_inSeek) {
          setState(() {
            _currentPositionText = extraValue;
          });
        }
      } else if (infoCode == FlutterAvpdef.BUFFEREDPOSITION) {
        _bufferPosition = extraValue;
        print(['获取缓存',extraValue]);
        setState(() {});
      } else if (infoCode == FlutterAvpdef.AUTOPLAYSTART) {
        Fluttertoast.showToast(msg: "AutoPlay");
      } else if (infoCode == FlutterAvpdef.CACHESUCCESS) {
        Fluttertoast.showToast(msg: "Cache Success");
      } else if (infoCode == FlutterAvpdef.CACHEERROR) {
        Fluttertoast.showToast(msg: "Cache Error $extraMsg");
      } else if (infoCode == FlutterAvpdef.LOOPINGSTART) {
        Fluttertoast.showToast(msg: "Looping Start");
      } else if (infoCode == FlutterAvpdef.SWITCHTOSOFTWAREVIDEODECODER) {
        Fluttertoast.showToast(msg: "change to soft ware decoder");
        mOptionsFragment.switchHardwareDecoder();
      }
    });
    //播放完成事件
    fAliplayer.setOnCompletion(() {
      _showTipsWidget = true;
      _showLoading = false;
      _tipsContent = "播放完成";
      setState(() {
        _currentPosition = _videoDuration;
      });
    });
    fAliplayer.setOnTrackReady(() {
      fAliplayer.getMediaInfo().then((value) {
        _videoDuration = value['duration'];
        setState(() {});
        List thumbnails = value['thumbnails'];
        print(['视频信息',value]);
        if (thumbnails != null && thumbnails.isNotEmpty) {
          fAliplayer.createThumbnailHelper(thumbnails[0]['url']);
        } else {
          _thumbnailSuccess = false;
        }
      });
      trackFragmentKey.currentState.loadData();
      setState(() {});
    });
//截图事件
    fAliplayer.setOnSnapShot((path) {
      print("aliyun : snapShotPath = $path");
      Fluttertoast.showToast(msg: "SnapShot Save : $path");
    });
    //  错误事件
    fAliplayer.setOnError((errorCode, errorExtra, errorMsg) {
      _showTipsWidget = true;
      _showLoading = false;
      _tipsContent = "$errorCode \n $errorMsg";
      setState(() {});
    });
    //切换码率，切换的结果会在OnTrackChangedListener监听之后回调（
    fAliplayer.setOnTrackChanged((value) {
      AVPTrackInfo info = AVPTrackInfo.fromJson(value);
      if (info != null && info.trackDefinition.length > 0) {
        trackFragmentKey.currentState.onTrackChanged(info);
        Fluttertoast.showToast(msg: "${info.trackDefinition}切换成功");
      }
    });

    fAliplayer.setOnThumbnailPreparedListener(preparedSuccess: () {
      _thumbnailSuccess = true;
    }, preparedFail: () {
      _thumbnailSuccess = false;
    });

    fAliplayer.setOnThumbnailGetListener(
        onThumbnailGetSuccess: (bitmap, range) {
          // _thumbnailBitmap = bitmap;
          var provider = MemoryImage(bitmap);
          precacheImage(provider, context).then((_) {
            print(['s缩略图',provider]);
            setState(() {
              _imageProvider = provider;
            });
          });
        },
        onThumbnailGetFail: () {});
    //隐藏字幕事件
    this.fAliplayer.setOnSubtitleHide((trackIndex, subtitleID) {
      if (mounted) {
        setState(() {
          extSubTitleText = '';
        });
      }
    });
    //显示字幕事件
    this.fAliplayer.setOnSubtitleShow((trackIndex, subtitleID, subtitle) {
      if (mounted) {
        setState(() {
          extSubTitleText = subtitle;
        });
      }
    });
    //网络状态监听
    _setNetworkChangedListener();
  }
  //网络状态监听
  _setNetworkChangedListener() {
    _networkSubscriptiion = Connectivity()
        .onConnectivityChanged
        .listen((ConnectivityResult result) {
      if (result == ConnectivityResult.mobile) {
        fAliplayer.pause();
        setState(() {
          _isShowMobileNetWork = true;
        });
      } else if (result == ConnectivityResult.wifi) {
        //从4G网络或者无网络切换到wifi
        if (_currentConnectivityResult == ConnectivityResult.mobile ||
            _currentConnectivityResult == ConnectivityResult.none) {
          fAliplayer.play();
        }
        setState(() {
          _isShowMobileNetWork = false;
        });
      }
      _currentConnectivityResult = result;
    });
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    switch (state) {
      case AppLifecycleState.inactive:
        break;
      case AppLifecycleState.resumed:
        _setNetworkChangedListener();
        break;
      case AppLifecycleState.paused:
        if (!_mEnablePlayBack) {
          fAliplayer.pause();
        }
        if (_networkSubscriptiion != null) {
          _networkSubscriptiion.cancel();
        }
        break;
      case AppLifecycleState.detached:
        break;
    }
  }

  @override
  void dispose() {
    // TODO: implement dispose
    _xjdhcontroller.dispose();
    _speeddhcontroller.dispose();
    _cleardhcontroller.dispose();
    SystemChrome.setPreferredOrientations(
        [DeviceOrientation.portraitUp, DeviceOrientation.portraitDown]);
    if (Platform.isIOS) {
      fAliplayer.enableMix(false);
    }
    fAliplayer.stop();
    fAliplayer.destroy();
    print("销毁播放器");
    super.dispose();
    WidgetsBinding.instance.removeObserver(this);// 移除监听器
    if (_networkSubscriptiion != null) {
      _networkSubscriptiion.cancel();
    }
  }

  @override
  Widget build(BuildContext context) {
//    SystemChrome.setEnabledSystemUIOverlays([]);//隐藏状态栏
    //准备播放
    var x = 0.0;
    var y = 0.0;
    Orientation orientation1 = MediaQuery.of(context).orientation;
    var width = MediaQuery.of(context).size.width;

    var height;
    if (orientation1 == Orientation.portrait) {
      height = width * 9.0 / 16.0;
    } else {
      height = MediaQuery.of(context).size.height;
    }
    print(['现在的方向',orientation1,height,'宽',width]);
    AliPlayerView aliPlayerView = AliPlayerView(
        onCreated: onViewPlayerCreated,
        x: 0.0,
        y: 0.0,
        width: width,
        height: height);
    //  OrientationBuilder根据屏幕方向更新ui
    return  OrientationBuilder(
      builder: (BuildContext context,Orientation orientation){
//        print(['现在的方向2',orientation]);
        return Stack(
          children: [
            Container(
              width: width,
              height: height,
              color: Colors.black,
              child: aliPlayerView,
            ),
            //loading
            _buildProgressBar(width, height),
            //视频准备中
            _buildVideoReady(width, height),
            //首屏图片
            _fristImg(width, height),
            //缩略图
            _buildThumbnail(width, height),
            //音量 亮度状态信息
            Positioned(
              top: height/3,
              child: Offstage(
                offstage:!isShowVolumeAndLight,
                child: Container(
                  width: width,
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    crossAxisAlignment: CrossAxisAlignment.baseline,
                    children: [
                      Text(isVolume?"音量":"亮度",style: TextStyle(color: Colors.white,height: 1.1,),),
                      Text((isVolume?(videoVolume~/0.01).toString():(brightness~/0.01).toString())+"%",style: TextStyle(color: Colors.white,height: 1.1,),)
                    ],
                  ),
                ),
              ),
            ),
            //手势监听--显示底部操作栏
            Positioned(
              left: 0,
              bottom:0,
              child: GestureDetector(
                behavior: HitTestBehavior.translucent,
                child: Container(
                  width: width,
                  height: height,
//                color: Colors.red,
//                child: aliPlayerView,
                ),
                onTap: (){
                  if(_dhStatus==1){
                    _xjdhcontroller.reverse();//反向动画
                    _cleardhcontroller.reverse();
                    _speeddhcontroller.reverse();
                  }else{
                    if(_isShowTap){
                      setState(() {
                        _isShowTap=false;
                      });
//                    SystemChrome.setEnabledSystemUIOverlays([]);//隐藏状态栏
                      _timer?.cancel();
                    }else{
                      setState(() {
                        _isShowTap=true;
                      });
//                    SystemChrome.setEnabledSystemUIOverlays(SystemUiOverlay.values);//显示状态栏
//                    _timer=new Timer(Duration(seconds: 10), () { //callback function
//                      setState(() {
//                        _isShowTap=false;
//                      });
//                      _dhcontroller.reverse();
//                    });
                    }
                  }
                  print(_dhStatus);
                  print('1111');

                },

                //垂直拖动开始事件回调。
                onVerticalDragStart:(v){
                  print(["开始长安",v.globalPosition.dx]);
                  if(v.globalPosition.dx<width/2){//左面是亮度 右面是音量
                    setState(() async{
                      isVolume=false;
                      isShowVolumeAndLight=true;
                      brightness= await Screen.brightness;
                      nowDy=v.globalPosition.dy;
                    });
                  }else{
                    setState(() {
                      isVolume=true;
                      isShowVolumeAndLight=true;
                      nowDy=v.globalPosition.dy;
                    });
                  }
                  print(['长按结果',v.globalPosition.dx<width/2,isVolume,isShowVolumeAndLight]);
                },
                //垂直指针移动更新事件回调
                 onVerticalDragUpdate:(v)async{

                  double _dragLength = (nowDy-v.globalPosition.dy);

                  if(isVolume){//是否为音量
                    double _videoVolume =_dragLength*0.01+videoVolume;
                    if(_videoVolume>1){
                      _videoVolume=1.0;
                    }else if(_videoVolume<0){
                      _videoVolume=0.0;
                    }else{
                      _videoVolume=double.parse(_videoVolume.toStringAsFixed(2));
                    }
                    fAliplayer.setVolume(_videoVolume);
                    setState(() {
                      videoVolume=_videoVolume;
                      nowDy=v.globalPosition.dy;
                    });
                  }else{//亮度
                    double _brightness =_dragLength*0.01+brightness;
                    if(_brightness>1){
                      _brightness=1.0;
                    }else if(_brightness<0){
                      _brightness=0.0;
                    }else{
                      _brightness=double.parse(_brightness.toStringAsFixed(2));
                    }
                    Screen.setBrightness(_brightness);
                    setState(() {
                      brightness=_brightness;
                      nowDy=v.globalPosition.dy;
                    });
                  }
                },
                //垂直拖动结束事件回调。
                onVerticalDragEnd:(v){
                  setState(() {
                    isShowVolumeAndLight=false;
                  });
                },
              ),
            ),
            //底部进度条
            Positioned(
              left: 0,
              bottom: 0,
              child: Offstage(
                offstage: !_isShowTap,
                child: Container(
                  width: width,
                  height: 0.3*height,
                  child:Visibility(
                    visible: orientation1 == Orientation.portrait,
                    child: _buildContentWidget(orientation),//竖屏进度条
                    replacement: _landscapeSlider(orientation),//横屏进度条
                  ),
                ),
              ),
            ),
            //倍速弹出框
            Positioned(
              right: HspSize.set(132),
              bottom: HspSize.set(48),
              child: Container(
                width: HspSize.set(50),
                height: _popBsHeight,
                color: Color.fromRGBO(0, 0, 0, 0.5),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: [
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("0.5倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        setState(() {
                          _playSpeed=0.5;
                        });
                        fAliplayer.setRate(0.5);
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("1.0倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        fAliplayer.setRate(1.0);
                        setState(() {
                          _playSpeed=1.0;
                        });
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("1.5倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        fAliplayer.setRate(1.5);
                        _speeddhcontroller.reverse();//反向动画
                        setState(() {
                          _playSpeed=1.5;
                        });
                      },
                    ),
                    InkWell(
                      child: Container(
                        height:_popBsHeight/5,
                        child: Text("2.0倍速",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popBsHeight/15)),),
                      ),
                      onTap: (){
                        setState(() {
                          _playSpeed=2.0;
                        });
                        fAliplayer.setRate(2.0);
                        _speeddhcontroller.reverse();//反向动画
                      },
                    ),
                  ],
                ),
              ),
            ),
            //清晰度弹出框
            Positioned(
              right: HspSize.set(38),
              bottom: HspSize.set(48),
              child: Container(
                width: HspSize.set(50),
                height: _popQxdHeight,
                color: Color.fromRGBO(0, 0, 0, 0.5),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: [
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("标清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("高清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                    InkWell(
                      child:Container(
                        height:_popQxdHeight/4,
                        child: Text("超清",style: TextStyle(color: Colors.white,fontSize: HspSize.set(_popQxdHeight/8.6)),),
                      ),
                      onTap: (){

                      },
                    ),
                  ],
                ),
              ),
            ),

            //选集右侧弹出框
            Positioned(
              right: 0,
              child: Container(
                alignment: Alignment.center,
                padding: EdgeInsets.only(left: HspSize.set(50),right:HspSize.set(50) ),
                width: _popWidth,
                height: height,
                color: Color.fromRGBO(44, 48, 57, 0.8),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: [
                    Text("选集",style: TextStyle(color: Colors.white),),
                    Container(
                      height: height*0.85,
                      child:SingleChildScrollView(
                        child:  Wrap(
                          spacing: 5,
                          runSpacing: 3,
                          crossAxisAlignment: WrapCrossAlignment.start,
                          children: List.generate(_dataSourceMap.length*5, (i) {
                            return InkWell(
                              child: Container(
                                alignment: Alignment.center,
                                height: 35,
                                width: 35,
                                decoration: BoxDecoration(
                                    color: Color.fromRGBO(61, 60, 68, 1),
                                    borderRadius: BorderRadius.all(Radius.circular(5))
                                ),
                                child: Text('${i+1}',style: TextStyle(color: Color.fromRGBO(210, 207, 218, 1)),),
                              ),
                              onTap: (){
                                print(['切换视频',i]);
                                setState(() {
                                  _videoIndex=i;
                                  _videoDuration=0;
                                  _currentPosition=0;
                                  _currentPlayerState=4;
                                  _showReadying = true;
                                  _isShowTap=false;
                                });
//                                fAliplayer.moveToNext();
                                fAliplayer.moveTo(uid:_videoIndex.toString());
                                fAliplayer.pause();
                                _xjdhcontroller.reverse();//反向动画
                              },
                            );
                          }),
                        ),
                      ),
                    )
                  ],
                ),
              ),
            ),

          ],
        );
      },
    );
  }

  void onViewPlayerCreated() async {
    switch (_playMode) {
      case ModeType.URL://UrlSource播放源
        if( widget.playType == HspPlayType.Live){
          this.fAliplayer.setUrl(_dataSourceMap);
        }else{
          _dataSourceMap.forEach((element) {
            print(['视频',element,element['url']]);
            this.fAliplayer.addUrlSource(url: element['url'], uid: element['id']);
          });
          this.fAliplayer.moveTo(uid:_videoIndex.toString());
          print([_videoIndex.toString()]);
        }



//        this.fAliplayer.setUrl(_dataSourceMap[_videoIndex]['url']);
        if(_isAutoPaly){
          this.fAliplayer.setAutoPlay(true);
        }

        setState(() {
          _showFristImg=false;
          _isShowTap=false;
        });
        this.fAliplayer.prepare();
        break;
//      case ModeType.STS://VidSts播放源
//        this.fAliplayer.setVidSts(
//            vid: _dataSourceMap[DataSourceRelated.VID_KEY],
//            region: _dataSourceMap[DataSourceRelated.REGION_KEY],
//            accessKeyId: _dataSourceMap[DataSourceRelated.ACCESSKEYID_KEY],
//            accessKeySecret:
//            _dataSourceMap[DataSourceRelated.ACCESSKEYSECRET_KEY],
//            securityToken: _dataSourceMap[DataSourceRelated.SECURITYTOKEN_KEY],
//            definitionList: _dataSourceMap[DataSourceRelated.DEFINITION_LIST],
//            previewTime: _dataSourceMap[DataSourceRelated.PREVIEWTIME_KEY]);
//            if(_isAutoPaly){
//              this.fAliplayer.setAutoPlay(true);
//            }
//            this.fAliplayer.prepare();
//        break;
//      case ModeType.AUTH://VidAuth播放源
//        this.fAliplayer.setVidAuth(
//            vid: _dataSourceMap[DataSourceRelated.VID_KEY],
//            region: _dataSourceMap[DataSourceRelated.REGION_KEY],
//            playAuth: _dataSourceMap[DataSourceRelated.PLAYAUTH_KEY],
//            definitionList: _dataSourceMap[DataSourceRelated.DEFINITION_LIST],
//            previewTime: _dataSourceMap[DataSourceRelated.PREVIEWTIME_KEY]);
//            if(_isAutoPaly){
//              this.fAliplayer.setAutoPlay(true);
//            }
//            this.fAliplayer.prepare();
//        break;
//      case ModeType.MPS://VidMps播放源
//        this.fAliplayer.setVidMps(_dataSourceMap);
//        if(_isAutoPaly){
//          this.fAliplayer.setAutoPlay(true);
//        }
//        this.fAliplayer.prepare();
//        break;
      default:
    }
  }

  //竖屏进度条
  _buildContentWidget(Orientation orientation) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Row(
          children: [
            SizedBox(
              width: 5.0,
            ),
            IconButton(
              icon: Icon(
                _currentPlayerState !=3
                    ? Icons.play_arrow
                    : Icons.pause,
                color: Colors.white,
              ),
              onPressed: () {
                if(widget.playType==HspPlayType.Demand){
                  if(_currentPlayerState==3){
                    fAliplayer.pause();
                  }else if(_currentPlayerState==4){
                    fAliplayer.play();
                  }else {
//                  fAliplayer.prepare();
                    fAliplayer.play();
                  }
                }
              },
            ),
            Text(
              "${FormatterUtils.getTimeformatByMs(_currentPositionText)}",
              style: TextStyle(color: Colors.white, fontSize: 11),
            ),
            //进度条
            Expanded(
              child: AliyunSlider(
                max: _videoDuration == 0 ? 1 : _videoDuration.toDouble(),
                min: 0,
                bufferColor: Colors.white,
                bufferValue: _bufferPosition.toDouble(),
                value: _currentPosition.toDouble(),
                onChangeStart: (value) {
                  _inSeek = true;
                  _showLoading = false;
                  setState(() {});
                },
                onChangeEnd: (value) {
                  _inSeek = false;
                  setState(() {
                    if (_currentPlayerState == FlutterAvpdef.completion &&
                        _showTipsWidget) {
                      setState(() {
                        _showTipsWidget = false;
                      });
                    }
                  });
                  fAliplayer.seekTo(
                      value.ceil(),
                      GlobalSettings.mEnableAccurateSeek
                          ? FlutterAvpdef.ACCURATE
                          : FlutterAvpdef.INACCURATE);
                },
                onChanged: (value) {
                  if (_thumbnailSuccess) {
                    fAliplayer.requestBitmapAtPosition(value.ceil());
                  }
                  setState(() {
                    _currentPosition = value.ceil();
                  });
                },
              ),
            ),
            Text(
              "${FormatterUtils.getTimeformatByMs(_videoDuration)}",
              style: TextStyle(color: Colors.white, fontSize: 11),
            ),
            IconButton(
              icon: Icon(
                Icons.fullscreen,
                color: Colors.white,
              ),
              onPressed: () {
                print(['现在是竖屏',_orientation]);
                SystemChrome.setEnabledSystemUIOverlays([]);//隐藏状态栏
                SystemChrome.setPreferredOrientations([
                  DeviceOrientation.landscapeLeft,
                  DeviceOrientation.landscapeRight
                ]);
              },
            ),
          ],
        ),
      ],
    );
  }
  //横屏进度条
  _landscapeSlider(Orientation orientation){
    return  Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Row(
          children: [
            SizedBox(width: 10,),
            Text(
              "${FormatterUtils.getTimeformatByMs(_currentPositionText)}",
              style: TextStyle(color: Colors.white, fontSize: 11),
            ),
            //进度条
            Expanded(
              child: AliyunSlider(
                max: _videoDuration == 0 ? 1 : _videoDuration.toDouble(),
                min: 0,
                bufferColor: Colors.white,
                bufferValue: _bufferPosition.toDouble(),
                value: _currentPosition.toDouble(),
                onChangeStart: (value) {
                  _inSeek = true;
                  _showLoading = false;
                  setState(() {});
                },
                onChangeEnd: (value) {
                  _inSeek = false;
                  setState(() {
                    if (_currentPlayerState == FlutterAvpdef.completion &&
                        _showTipsWidget) {
                      setState(() {
                        _showTipsWidget = false;
                      });
                    }
                  });
                  fAliplayer.seekTo(
                      value.ceil(),
                      GlobalSettings.mEnableAccurateSeek
                          ? FlutterAvpdef.ACCURATE
                          : FlutterAvpdef.INACCURATE);
                },
                onChanged: (value) {
                  if (_thumbnailSuccess) {
                    fAliplayer.requestBitmapAtPosition(value.ceil());
                  }
                  setState(() {
                    _currentPosition = value.ceil();
                  });
                },
              ),
            ),
            Text(
              "${FormatterUtils.getTimeformatByMs(_videoDuration)}",
              style: TextStyle(color: Colors.white, fontSize: 11),
            ),
            SizedBox(width: 10,)
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Container(
              child: Row(
                children: [
                  //播放暂停
                  IconButton(
                    icon: Icon(
                      _currentPlayerState !=3
                          ? Icons.play_arrow
                          : Icons.pause,
                      color: Colors.white,
                    ),
                    onPressed: () {
                      if(_currentPlayerState==3){
                        fAliplayer.pause();
                      }else if(_currentPlayerState==4){
                        fAliplayer.play();
                      }else {
                        fAliplayer.prepare();
                        fAliplayer.play();
                      }
                    },
                  ),
                  //下一集
                  IconButton(
                    icon: Icon(Icons.skip_next,size: HspSize.set(28),
                      color: Colors.white,
                    ),
                    onPressed: () {
                      setState(() {
                        _videoDuration=0;
                        _currentPosition=0;
                        _currentPlayerState=4;
                        _showReadying = true;
                        _isShowTap=false;
                      });
//                                fAliplayer.moveToNext();
                      fAliplayer.moveToNext();
                      fAliplayer.pause();
                    },
                  ),
                ],
              ),
            ),
            Container(
              child: Row(
                children: [
                  InkWell(
                    child: Text(_playSpeed==1.0?"1.0x":(_playSpeed==0.5?'0.5x':_playSpeed==1.5?'1.5x':'2.0x'),textDirection:TextDirection.rtl,style: TextStyle(color: Colors.white,height: 1),),
                    onTap: (){
                      _cleardhcontroller.reverse();
                      _xjdhcontroller.reverse();
                      print(['倍速',_dhStatus]);
                      if(_dhStatus==0){
                        _speeddhcontroller.forward();
                      }else{
                        _speeddhcontroller.reverse();//反向动画
                      }
                      print(['倍速1',_dhStatus]);
                    },
                  ),
                  SizedBox(
                    width: HspSize.set(20),
                  ),
                  InkWell(
                    child: Text("选集",style: TextStyle(color: Colors.white,height: 1),),
                    onTap: (){
                      _speeddhcontroller.reverse();
                      _cleardhcontroller.reverse();
                      print(['选集',_dhStatus]);
                      if(_dhStatus==0){
                        _xjdhcontroller.forward();
                      }else{
                        _xjdhcontroller.reverse();//反向动画
                      }
                      print(['选集1',_dhStatus]);
                    },
                  ),
                  SizedBox(
                    width: HspSize.set(20),
                  ),
                  InkWell(
                    child: Text("高清",style: TextStyle(color: Colors.white,height: 1),),
                    onTap: (){
                      _speeddhcontroller.reverse();
                      _xjdhcontroller.reverse();
                      print(['高清',_dhStatus]);
                      if(_dhStatus==0){
                        _cleardhcontroller.forward();
                      }else{
                        _cleardhcontroller.reverse();//反向动画
                      }
                      print(['高清1',_dhStatus]);
                    },
                  ),
                  //竖屏
                  IconButton(
                    icon: Icon(
                      Icons.fullscreen_exit,
                      color: Colors.white,
                    ),
                    onPressed: () {
                      print(['现在是横屏',_orientation]);
                        SystemChrome.setEnabledSystemUIOverlays(SystemUiOverlay.values);//显示状态栏s
                      SystemChrome.setPreferredOrientations([
                        DeviceOrientation.portraitUp,
                        DeviceOrientation.portraitDown
                      ]);
                    },
                  ),
                ],
              ),
            )
          ],
        ),
      ],
    );
  }

  ///缩略图
  _buildThumbnail(double width, double height) {
    if (_inSeek && _thumbnailSuccess) {
      return Container(
        alignment: Alignment.center,
        width: width,
        height: height,
        child: Wrap(
          direction: Axis.vertical,
          crossAxisAlignment: WrapCrossAlignment.center,
          children: [
            Text("${FormatterUtils.getTimeformatByMs(_currentPosition)}",
                style: TextStyle(color: Colors.white),
                textAlign: TextAlign.center),
            _imageProvider == null
                ? Container()
                : Image(
              width: width / 2,
              height: height / 2,
              image: _imageProvider,
            ),
          ],
        ),
      );
    } else {
      return Container();
    }
  }

  ///Loading
  _buildProgressBar(double width, double height) {
    if (_showLoading) {
      return Positioned(
        left: width / 2 - 20,
        top: height / 2 - 20,
        child: Column(
          children: [
            CircularProgressIndicator(
              backgroundColor: Colors.white,
              strokeWidth: 3.0,
            ),
            SizedBox(
              height: 10.0,
            ),
            Text(
              "$_loadingPercent%",
              style: TextStyle(color: Colors.white),
            ),
          ],
        ),
      );
    } else {
      return SizedBox();
    }
  }

  ///视频准备中
  _buildVideoReady(double width, double height) {
    if (_showReadying) {
      return Container(
        width: width ,
        height: height,
        color: Colors.black,
        alignment: Alignment.center,
        child:widget.xuanChuanImg==null?Column(
          crossAxisAlignment: CrossAxisAlignment.center,
          children: [
            CircularProgressIndicator(
              backgroundColor: Colors.white,
              strokeWidth: 3.0,
            ),
            SizedBox(
              height: 10.0,
            ),
            Container(
              alignment: Alignment.center,
              width: 100,
              child: Text(
                "努力加载中...",
                style: TextStyle(color: Colors.white),
              ),
            ),
          ],
        ):Container(
            width: 100,
            height: 63,
            decoration: BoxDecoration(
              image: DecorationImage(
                image: NetworkImage(widget.xuanChuanImg),
                fit: BoxFit.cover
              )
            ),
          ),
      );
    } else {
      return SizedBox();
    }
  }

  //首频图片
  _fristImg(double width, double height){
    return _showFristImg? Container(
      width: width,
      height: height,
      decoration: BoxDecoration(
        image: DecorationImage(
          image: NetworkImage(widget.thumbnail),
          fit: BoxFit.cover
        )
      ),
    ):Container();
  }
}


class GlobalSettings {
  ///软硬解开关
  static bool mEnableHardwareDecoder = true;

  ///播放器日志开关
  static bool mEnableAliPlayerLog = true;

  ///播放器日志级别
  static int mLogLevel = FlutterAvpdef.AF_LOG_LEVEL_INFO;

  ///是否是精准seek
  static bool mEnableAccurateSeek = false;
}

/// 播放方式
enum ModeType { URL, STS, AUTH, MPS }
//播放方式:直播 点播
enum HspPlayType {Live,Demand}



///播放源相关
class DataSourceRelated {
  static const String DEFAULT_REGION = "cn-shanghai";
  static const String DEFAULT_VID = "6b357371ef3c45f4a06e2536fd534380";

  static const String DEFAULT_URL =
      "https://alivc-demo-vod.aliyuncs.com/6b357371ef3c45f4a06e2536fd534380/53733986bce75cfc367d7554a47638c0-fd.mp4";

  static const String TYPE_KEY = "type";
  static const String REGION_KEY = "region";
  static const String URL_KEY = "url";
  static const String VID_KEY = "vid";
  static const String INDEX_KEY = "index";
  static const String ACCESSKEYID_KEY = "accessKeyId";
  static const String ACCESSKEYSECRET_KEY = "accessKeySecret";
  static const String SECURITYTOKEN_KEY = "securityToken";
  static const String PREVIEWTIME_KEY = "previewTime";
  static const String PLAYAUTH_KEY = "playAuth";
  static const String PLAYDOMAIN_KEY = "playDomain";
  static const String AUTHINFO_KEY = "authInfo";
  static const String HLSURITOKEN_KEY = "hlsUriToken";
  static const String DOWNLOAD_SAVE_PATH = "savePath";
  static const String DEFINITION_LIST = "definitionList";
}
